=== thirdparty/compoundfilereader/CMakeLists.txt ===
add_library( compoundfilereader INTERFACE )

target_include_directories( compoundfilereader INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} )
